import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.*;


/**
  * Klasse <var>JDBC</var>
  * Dies ist ein Beispiel fuer den Zugriff auf eine Datenbank 
  * ueber JDBC.
  * Dieses Programm testet die Funktionalitt 
  * der Klasse Database, welche in dem Servlet-Beispiel 
  * eingesetzt wird.
  * @author Sven Garske und Jrn Hauswald
  * @verison Projektstudium SS98
  */ 



public class JDBC
{

   static Connection con;  

   /**
     * Initialisieren : Laden des Treibers 
     *                  Aufbau der Verbindung zur DB
     */
   public static void init() 
   {
      //Treibername : hier ein JDBC-ODBC-Brckentreiber
      String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
      try
      {
	 // JDBC-Treiber laden
	 Class.forName(driver);

	 // JDBC-URL zur Datenbank ps 
         String url="jdbc:odbc:ps";
      
         // Aufbau der Verbindung
         con=DriverManager.getConnection(url);
       
      }
      catch(ClassNotFoundException e)
      {
	 System.err.println("JDBC-Treiber "
			    + driver + " nicht geladen");
	 e.printStackTrace(System.err) ;
      }
      catch (SQLException e2)
      {
         System.err.println("Fehler bei DB-Connection "+e2.getMessage());
      }
   }



   /**
    * doSQL fuehrt die SQL-Anweisungen aus
    */
   private static void doSQL ()
   {
    try {

     //Abfrage Gruppen
//     queryAusfuehren("SELECT * FROM gruppen");

     //Abfragen der Teilnehmer
//     queryAusfuehren("SELECT * FROM teilnehmer");

     //Abfrage Protokolleintrge
       queryAusfuehren("SELECT * FROM protokoll");   

    }
    catch (SQLException e1){
         System.out.println("Fehler "+e1.getMessage());
    }     
     
   }/* doSQL() */
    
  /**
    * queryGruppen bergibt Database die SQL-Anfrage
    * und gibt das Ergebnis auf System.out aus
    */
  public static void queryAusfuehren(String sql) throws SQLException {

     //Dies wird nur erzeugt,da es fr das Servlet noetig ist
     ByteArrayOutputStream b = new ByteArrayOutputStream(5000);
     PrintWriter out = new PrintWriter(new OutputStreamWriter(b));

     Database db=new Database(con,sql);
  
     try {    
      //Schreiben des Ergebnisses in PrintWriter
      //outputResultSet:wertet Anfrage aus,die von execSQL ausgefuehrt wurde
      out.println(db.outputResultSet(db.execSQL()));

      //Schlieen des PrintWriter
      out.close();

      //Ausgabe des ByteArrayOutputStream auf Standardausgabe
      b.writeTo(System.out);
     } 
     catch (IOException e) {
               System.out.println("Fehler : "+e.getMessage());
     }

   }/* queryAusfuehren() */


 
 /**
   * Hauptroutine die init und doSQL ausfhrt
   */
public static void main(String[] args){

      init();
      doSQL();                    
}/* main */

}/* end Klasse JDBCServlet */
